diff -r 3da9153bcf2d -r 0324c269b390 javafx-ui-common/src/javafx/scene/shape/TriangleMesh.java
--- a/javafx-ui-common/src/javafx/scene/shape/TriangleMesh.java	Mon Apr 22 17:59:31 2013 +0100
+++ b/javafx-ui-common/src/javafx/scene/shape/TriangleMesh.java	Mon Apr 22 15:45:02 2013 -0700
@@ -25,6 +25,10 @@
 
 package javafx.scene.shape;
 
+import com.sun.javafx.collections.FloatArraySyncer;
+import com.sun.javafx.collections.IntegerArraySyncer;
+import javafx.collections.ObservableIntegerArray;
+import javafx.collections.ObservableFloatArray;
 import com.sun.javafx.geom.BaseBounds;
 import com.sun.javafx.geom.BoxBounds;
 import com.sun.javafx.geom.PickRay;
@@ -32,8 +36,9 @@
 import com.sun.javafx.scene.input.PickResultChooser;
 import com.sun.javafx.sg.PGTriangleMesh;
 import com.sun.javafx.tk.Toolkit;
-import javafx.beans.property.ReadOnlyIntegerProperty;
-import javafx.beans.property.ReadOnlyIntegerWrapper;
+import javafx.beans.property.BooleanProperty;
+import javafx.beans.value.ChangeListener;
+import javafx.beans.value.ObservableValue;
 import javafx.geometry.Point2D;
 import javafx.geometry.Point3D;
 import javafx.scene.Node;
@@ -79,29 +84,12 @@
     public static final int NUM_COMPONENTS_PER_TEXCOORD = 2;
     public static final int NUM_COMPONENTS_PER_FACE = 6;
 
-    private float[] points;
-    private float[] texCoords;
-    private int[] faces;
-    private int[] faceSmoothingGroups;
+    private FloatArraySyncer points = new FloatArraySyncer(new ObservableFloatArray(NUM_COMPONENTS_PER_POINT), dirtyProperty());
+    private FloatArraySyncer texCoords = new FloatArraySyncer(new ObservableFloatArray(NUM_COMPONENTS_PER_TEXCOORD), dirtyProperty());
+    private IntegerArraySyncer faces = new IntegerArraySyncer(new ObservableIntegerArray(NUM_COMPONENTS_PER_FACE), dirtyProperty());
+    private IntegerArraySyncer faceSmoothingGroups = new IntegerArraySyncer(new ObservableIntegerArray(), dirtyProperty());
 
-    private boolean pointsDirty = true;
-    private boolean texCoordsDirty = true;
-    private boolean facesDirty = true;
-    private boolean fsgDirty = true;
-
-    // Partial Update constants and variables
-    private static final int RANGE_INDEX = 0;
-    private static final int RANGE_LENGTH = 1;
-    private static final int MAX_RANGE_SIZE = 2;
     private int refCount = 1;
-    private boolean pointUpdateRange = false;   
-    private int[] pointRangeInfos;
-    private boolean texCoordUpdateRange = false;
-    private int[] texCoordRangeInfos;
-    private boolean faceUpdateRange = false;
-    private int[] faceRangeInfos;
-    private boolean fsgUpdateRange = false;
-    private int[] fsgRangeInfos;
 
     private BaseBounds cachedBounds;
 
@@ -122,499 +110,66 @@
      * by NUM_COMPONENTS_PER_FACE)
      */
     public TriangleMesh(float[] points, float[] texCoords, int[] faces) {
-        setPoints(points);
-        setTexCoords(texCoords);
-        setFaces(faces);
+        this.points.get().set(points);
+        this.texCoords.get().set(texCoords);
+        this.faces.get().set(faces);
+    }
+    /**
+     * Creates a new instance of {@code TriangleMesh} class.
+     * TODO: 3D - doc. follows array semantic
+     *
+     * @param points points array (points.length must be divisible by NUM_COMPONENTS_PER_POINT)
+     * @param texCoords texCoords array (texCoords.length must be divisible by
+     * NUM_COMPONENTS_PER_TEXCOORD)
+     * @param faces faces (or triangles) array (faces.length must be divisible
+     * by NUM_COMPONENTS_PER_FACE)
+     */
+    public TriangleMesh(float[] points, float[] texCoords, int[] faces, int[] faceSmoothingGroups) {
+        this.points.get().set(points);
+        this.texCoords.get().set(texCoords);
+        this.faces.get().set(faces);
+        this.faceSmoothingGroups.get().set(faceSmoothingGroups);
     }
 
     /**
-     * The total number of points of this {@code TriangleMesh}
-     */
-    private ReadOnlyIntegerWrapper pointCount;
-
-    final void setPointCount(int value) {
-        pointCountPropertyImpl().set(value);
+     * Gets the {@code ObservableFloatArray} of points of this {@code TriangleMesh}.
+     *
+     * @return {@code ObservableFloatArray} of points where each point is
+     * represented by 3 float values x, y and z, in that order.
+     */    
+    public ObservableFloatArray getPoints() {
+        return points.get();
     }
 
     /**
-     * Retrieve total number of points of this {@code TriangleMesh}
+     * Gets the {@code ObservableFloatArray} of texture coordinates of this {@code TriangleMesh}.
      *
-     * @return the total number of points
-     */
-    public final int getPointCount() {
-        return pointCount == null ? 0 : pointCount.get();
+     * @return {@code ObservableFloatArray} array of texture coordinates
+     * where each texture coordinate is represented by 2 float values: u and v,
+     * in that order
+     */    
+    public ObservableFloatArray getTexCoords() {
+        return texCoords.get();
     }
-
-    public ReadOnlyIntegerProperty pointCountProperty() {
-        return pointCountPropertyImpl().getReadOnlyProperty();
-    }
-
-    private ReadOnlyIntegerWrapper pointCountPropertyImpl() {
-        if (pointCount == null) {
-            pointCount = new ReadOnlyIntegerWrapper(this, "pointCount");
-        }
-        return pointCount;
+ 
+    /**
+     * Gets the {@code ObservableIntegerArray} of faces, indices into the points 
+     * and texCoords arrays, of this  {@code TriangleMesh}
+     *
+     * @return {@code ObservableIntegerArray} of faces where each face is
+     * 6 integers p0, t0, p1, t1, p3, t3, where p0, p1 and p2 are indices of 
+     * points in points {@code ObservableFloatArray} and t0, t1 and t2 are 
+     * indices of texture coordinates in texCoords {@code ObservableFloatArray}.
+     * Both indices are in terms of elements (points or textCoords), not individual
+     * floats.
+     */    
+    public ObservableIntegerArray getFaces() {
+        return faces.get();
     }
 
     /**
-     * The total number of texture coordinates of this {@code TriangleMesh}
-     */
-    private ReadOnlyIntegerWrapper texCoordCount;
-
-    final void setTexCoordCount(int value) {
-        texCoordCountPropertyImpl().set(value);
-    }
-
-    /**
-     * Retrieve total number of texture coordinates of this {@code TriangleMesh}
-     *
-     * @return the total number of texture coordinates
-     */
-    public final int getTexCoordCount() {
-        return texCoordCount == null ? 0 : texCoordCount.get();
-    }
-
-    public ReadOnlyIntegerProperty texCoordCountProperty() {
-        return texCoordCountPropertyImpl().getReadOnlyProperty();
-    }
-
-    private ReadOnlyIntegerWrapper texCoordCountPropertyImpl() {
-        if (texCoordCount == null) {
-            texCoordCount = new ReadOnlyIntegerWrapper(this, "texCoordCount");
-        }
-        return texCoordCount;
-    }
-
-    /**
-     * The total number of faces of this {@code TriangleMesh}
-     */
-    private ReadOnlyIntegerWrapper faceCount;
-
-    final void setFaceCount(int value) {
-        faceCountPropertyImpl().set(value);
-    }
-
-    /**
-     * Retrieve total number of faces of this {@code TriangleMesh}
-     *
-     * @return the total number of faces
-     */
-    public final int getFaceCount() {
-        return faceCount == null ? 0 : faceCount.get();
-    }
-
-    public ReadOnlyIntegerProperty faceCountProperty() {
-        return faceCountPropertyImpl().getReadOnlyProperty();
-    }
-
-    private ReadOnlyIntegerWrapper faceCountPropertyImpl() {
-        if (faceCount == null) {
-            faceCount = new ReadOnlyIntegerWrapper(this, "faceCount");
-        }
-        return faceCount;
-    }
-    
-    /**
-     * The total number of faceSmoothingGroups of this {@code TriangleMesh}
-     */
-    private ReadOnlyIntegerWrapper faceSmoothingGroupCount;
-
-    final void setFaceSmoothingGroupCount(int value) {
-        faceSmoothingGroupCountPropertyImpl().set(value);
-    }
-
-    /**
-     * Retrieve total number of faceSmoothingGroups of this {@code TriangleMesh}
-     *
-     * @return the total number of faceSmoothingGroups
-     */
-    public final int getFaceSmoothingGroupCount() {
-        return faceSmoothingGroupCount == null ? 0 : faceSmoothingGroupCount.get();
-    }
-
-    public ReadOnlyIntegerProperty faceSmoothingGroupCountProperty() {
-        return faceSmoothingGroupCountPropertyImpl().getReadOnlyProperty();
-    }
-
-    private ReadOnlyIntegerWrapper faceSmoothingGroupCountPropertyImpl() {
-        if (faceSmoothingGroupCount == null) {
-            faceSmoothingGroupCount = new ReadOnlyIntegerWrapper(this, "faceSmoothingGroupCount");
-        }
-        return faceSmoothingGroupCount;
-    }
-
-    /**
-     * Sets the points of this {@code TriangleMesh}
-     * 
-     * @param points source array of NUM_COMPONENTS_PER_POINT * n values containing n new points.
-     */
-    public final void setPoints(float[] points) {
-        // Check that points.length is divisible by NUM_COMPONENTS_PER_POINT
-        if ((points.length % NUM_COMPONENTS_PER_POINT) != 0) {
-            throw new IllegalArgumentException("points.length has to be divisible by NUM_COMPONENTS_PER_POINT." 
-                    + " It is to store multiple x, y, and z coordinates of this mesh");
-        }
-
-        if ((this.points == null) || (this.points.length < points.length)) {
-            this.points = new float[points.length];
-        }
-        System.arraycopy(points, 0, this.points, 0, points.length);
-        // Store the valid point count.
-        // Note this.points.length can be bigger than points.length.
-        setPointCount(points.length / NUM_COMPONENTS_PER_POINT);
-
-        pointsDirty = true;
-        setDirty(true);
-    }
-    
-    /**
-     * Sets the points associated with this {@code TriangleMesh}
-     * starting at the specified {@code index} using data in {@code points} 
-     * starting at index {@code start} for {@code length} number of points.
-     * 
-     * @param index the starting destination index in this TriangleMesh's points array
-     * @param points source array of floats containing the new points
-     * @param start starting source index in the points array.
-     * @param length number of point elements to be copied.
-     */
-    public final void setPoints(int index, float[] points,
-                      int start, int length) {
-
-        if (index < 0 || start < 0 || length < 0) {
-            throw new IllegalArgumentException("index, start and length have to be non-zero");
-        }
-        int startOffset = start * NUM_COMPONENTS_PER_POINT;
-        int lengthInFloatUnit = length * NUM_COMPONENTS_PER_POINT;
-        if ((startOffset >= points.length) || ((startOffset + lengthInFloatUnit) > points.length)) {
-            throw new IllegalArgumentException("start or (start + length) is out of range for input points");
-        }
-        int indexOffset = index * NUM_COMPONENTS_PER_POINT;
-        int pointCountInFloatUnit = getPointCount() * NUM_COMPONENTS_PER_POINT;
-        if ((indexOffset >= pointCountInFloatUnit) || 
-                ((indexOffset + lengthInFloatUnit) > pointCountInFloatUnit)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's points");
-        }
-        System.arraycopy(points, startOffset, this.points, indexOffset, lengthInFloatUnit);
-
-        if (pointRangeInfos == null) {
-            pointRangeInfos = new int[MAX_RANGE_SIZE];
-        }
-
-        if (!pointUpdateRange) {
-            pointsDirty = pointUpdateRange = true;
-            pointRangeInfos[RANGE_INDEX] = index;
-            pointRangeInfos[RANGE_LENGTH] = length;
-        } else {
-            pointsDirty = true;
-            int fromIndex = Math.min(pointRangeInfos[RANGE_INDEX], index);
-            int toIndex = Math.max(pointRangeInfos[RANGE_INDEX] + pointRangeInfos[RANGE_LENGTH], index + length);
-            pointRangeInfos[RANGE_INDEX] = fromIndex;
-            pointRangeInfos[RANGE_LENGTH] = toIndex - fromIndex;
-        }
-        
-        setDirty(true);
-    }
-    
-    /**
-     * Gets the points of this {@code TriangleMesh}
-     *
-     * @param points a float array that will receive the points
-     * if it not null and has sufficient capacity.
-     * @return a float array of points
-     */
-    public final float[] getPoints(float[] points) {
-        if (this.points == null) {
-            return null;
-        }
-        int pointCountInFloatUnit = getPointCount() * NUM_COMPONENTS_PER_POINT;
-        if ((points == null) || (pointCountInFloatUnit > points.length)) {
-            points = new float[pointCountInFloatUnit];
-        }
-        System.arraycopy(this.points, 0, points, 0, pointCountInFloatUnit);
-        return points;
-    }
-
-    /**
-     * Gets the points associated with this {@code TriangleMesh} starting at the
-     * specified {@code index} for {@code length} number of points.
-     * 
-     * @param index starting source points index in this {@code TriangleMesh}
-     * @param points destination array that will receive this {@code TriangleMesh}'s points data
-     * @param length number of point elements to be copied
-     * @return a float array of points
-     */
-    public final float[] getPoints(int index, float[] points, int length) {
-        if (index < 0 || length < 0) {
-            throw new IllegalArgumentException("index and length have to be non-zero");
-        }
-
-        int lengthInFloatUnit = length * NUM_COMPONENTS_PER_POINT;
-        if (lengthInFloatUnit > points.length) {
-            throw new IllegalArgumentException("length is out of range for input points");
-        }
-        int indexOffset = index * NUM_COMPONENTS_PER_POINT;
-        int pointCountInFloatUnit = getPointCount() * NUM_COMPONENTS_PER_POINT;
-        if ((indexOffset >= pointCountInFloatUnit) || 
-                ((indexOffset + lengthInFloatUnit) > pointCountInFloatUnit)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's points");
-        }
-
-        if (this.points == null) {
-            return null;
-        }
-        System.arraycopy(this.points, indexOffset, points, 0, lengthInFloatUnit);
-        return points;
-    }
-    
-    /**
-     * Sets the texture coordinates of this {@code TriangleMesh}.
-     * 
-     * @param texCoords source array of NUM_COMPONENTS_PER_TEXCOORD * n values containing n new texCoords.
-     */
-    public final void setTexCoords(float[] texCoords) {
-        // Check that texCoords.length is divisible by NUM_COMPONENTS_PER_TEXCOORD
-        if ((texCoords.length % NUM_COMPONENTS_PER_TEXCOORD) != 0) {
-            throw new IllegalArgumentException("texCoords.length has to be divisible by NUM_COMPONENTS_PER_TEXCOORD."
-                    +" It is to store multiple u and v texture coordinates of this mesh");
-        }
-
-        if ((this.texCoords == null) || (this.texCoords.length < texCoords.length)) {
-            this.texCoords = new float[texCoords.length];
-        }
-        System.arraycopy(texCoords, 0, this.texCoords, 0, texCoords.length);
-        // Store the valid texCoords count.
-        // Note this.texCoords.length can be bigger than texCoords.length.
-        setTexCoordCount(texCoords.length / NUM_COMPONENTS_PER_TEXCOORD);
-
-        texCoordsDirty = true;
-        setDirty(true);
-    }
-
-    /**
-     * Sets the texture coordinates associated with this {@code TriangleMesh}
-     * starting at the specified {@code index} using data in {@code texCoords}
-     * starting at index {@code start} for {@code length} number of texCoords.
-     * 
-     * @param index the starting destination index in this TriangleMesh's texCoords array
-     * @param texCoords an float array containing the new texture coordinates
-     * @param start starting source index in the texture coordinates array
-     * @param length number of texCoord elements to be copied.
-     */
-    public final void setTexCoords(int index, float[] texCoords, int start,
-            int length) {
-        if (index < 0 || start < 0 || length < 0) {
-            throw new IllegalArgumentException("index, start and length have to be non-zero");
-        }
-        int startOffset = start * NUM_COMPONENTS_PER_TEXCOORD;
-        int lengthInFloatUnit = length * NUM_COMPONENTS_PER_TEXCOORD;
-        if ((startOffset >= texCoords.length) || ((startOffset + lengthInFloatUnit) > texCoords.length)) {
-            throw new IllegalArgumentException("start or (start + length) is out of range for input texCoords");
-        }
-        int indexOffset = index * NUM_COMPONENTS_PER_TEXCOORD;
-        int texCoordCountInFloatUnit = getTexCoordCount() * NUM_COMPONENTS_PER_TEXCOORD;
-        if ((indexOffset >= texCoordCountInFloatUnit) || 
-                ((indexOffset + lengthInFloatUnit) > texCoordCountInFloatUnit)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's texCoords");
-        }
-        System.arraycopy(texCoords, startOffset, this.texCoords, indexOffset, lengthInFloatUnit);
-      
-        if (texCoordRangeInfos == null) {
-            texCoordRangeInfos = new int[MAX_RANGE_SIZE];
-        }
-        if (!texCoordUpdateRange) {
-            texCoordsDirty = texCoordUpdateRange = true;
-            texCoordRangeInfos[RANGE_INDEX] = index;
-            texCoordRangeInfos[RANGE_LENGTH] = length;
-        } else {
-            texCoordsDirty = true;
-            int fromIndex = Math.min(texCoordRangeInfos[RANGE_INDEX], index);
-            int toIndex = Math.max(texCoordRangeInfos[RANGE_INDEX] + texCoordRangeInfos[RANGE_LENGTH], index + length);
-            texCoordRangeInfos[RANGE_INDEX] = fromIndex;
-            texCoordRangeInfos[RANGE_LENGTH] = toIndex - fromIndex;            
-        }
-        setDirty(true);
-    }
-
-    /**
-     * Gets the texture coordinates of this {@code TriangleMesh}.
-     *
-     * @param texCoords a float array that will receive the texture coordinates
-     * if it not null and has sufficient capacity
-     * @return a float array of texture coordinates
-     */
-    public final float[] getTexCoords(float[] texCoords) {
-        if (this.texCoords == null) {
-            return null;
-        }
-
-        int texCoordCountInFloatUnit = getTexCoordCount() * NUM_COMPONENTS_PER_TEXCOORD;
-        if ((texCoords == null) || (texCoordCountInFloatUnit > texCoords.length)) {
-            texCoords = new float[texCoordCountInFloatUnit];
-        }
-        System.arraycopy(this.texCoords, 0, texCoords, 0, texCoordCountInFloatUnit);
-        return texCoords;
-    }
-
-    /**
-     * Gets the texture coordinates associated with this {@code TriangleMesh}
-     * starting at the specified {@code index} for {@code length} number of
-     * texCoords.
-     * 
-     * @param index starting source texCoords index in this {@code TriangleMesh}
-     * @param texCoords destination array that will receive this {@code TriangleMesh}'s texCoords data 
-     * @param length number of texCoord elements to be copied
-     * @return a float array of texture coordinates
-     */
-    public final float[] getTexCoords(int index, float[] texCoords, int length) {
-        if (index < 0 || length < 0) {
-            throw new IllegalArgumentException("index and length have to be non-zero");
-        }
-
-        int lengthInFloatUnit = length * NUM_COMPONENTS_PER_TEXCOORD;
-        if (lengthInFloatUnit > texCoords.length) {
-            throw new IllegalArgumentException("length is out of range for input texCoords");
-        }
-        int indexOffset = index * NUM_COMPONENTS_PER_TEXCOORD;
-        int texCoordCountInFloatUnit = getTexCoordCount() * NUM_COMPONENTS_PER_TEXCOORD;
-        if ((indexOffset >= texCoordCountInFloatUnit) || 
-                ((indexOffset + lengthInFloatUnit) > texCoordCountInFloatUnit)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's texCoords");
-        }
-
-        if (this.texCoords == null) {
-            return null;
-        }
-        System.arraycopy(this.texCoords, indexOffset, texCoords, 0, lengthInFloatUnit);
-        return texCoords;
-    }
-
-    /**
-     * Sets the faces, indices into the points and texCoords arrays,
-     * associated with this {@code TriangleMesh}.
-     * 
-     * @param faces source array of NUM_COMPONENTS_PER_FACE * n indices 
-     * (3 point indices and 3 texCood indices) containing n new faces
-     */
-    public final void setFaces(int[] faces) {
-        // Check that faces.length is divisible by NUM_COMPONENTS_PER_FACE
-        if ((faces.length % NUM_COMPONENTS_PER_FACE) != 0) {
-            throw new IllegalArgumentException("faces.length has to be divisible by NUM_COMPONENTS_PER_FACE.");
-        }
-
-        if ((this.faces == null) || (this.faces.length < faces.length)) {
-            this.faces = new int[faces.length];
-        }
-        System.arraycopy(faces, 0, this.faces, 0, faces.length);
-        // Store the valid face count.
-        // Note this.faces.length can be bigger than faces.length.
-        setFaceCount(faces.length / NUM_COMPONENTS_PER_FACE);
-
-        facesDirty = true;
-        setDirty(true);
-    }
-
-    /**
-     * Sets the faces, indices into the points and texCoords arrays, 
-     * associated with this {@code TriangleMesh}
-     * starting at the specified{@code index} using data in {@code faces} 
-     * starting at index {@code start} for {@code length} number of faces.
-     * 
-     * @param index the starting destination index in this TriangleMesh's faces array
-     * @param faces an int array containing the new interleaved vertices
-     * @param start starting source index in the faces array.
-     * @param length number of interleaved vertex elements to be copied
-     */
-    public final void setFaces(int index, int[] faces, int start, int length) {
-        if (index < 0 || start < 0 || length < 0) {
-            throw new IllegalArgumentException("index, start and length have to be non-zero");
-        }
-        int startOffset = start * NUM_COMPONENTS_PER_FACE;
-        int lengthInIntUnit = length * NUM_COMPONENTS_PER_FACE;
-        if ((startOffset >= faces.length) || ((startOffset + lengthInIntUnit) > faces.length)) {
-            throw new IllegalArgumentException("start or (start + length) is out of range for input faces");
-        }
-        int indexOffset = index * NUM_COMPONENTS_PER_FACE;
-        int faceCountInIntUnit = getFaceCount() * NUM_COMPONENTS_PER_FACE;
-        if ((indexOffset >= faceCountInIntUnit) || 
-                ((indexOffset + lengthInIntUnit) > faceCountInIntUnit)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's faces");
-        }
-        System.arraycopy(faces, startOffset, this.faces, indexOffset, lengthInIntUnit);
-
-        if (faceRangeInfos == null) {
-            faceRangeInfos = new int[MAX_RANGE_SIZE];
-        }
-        if (!faceUpdateRange) {
-            facesDirty = faceUpdateRange = true;
-            faceRangeInfos[RANGE_INDEX] = index;
-            faceRangeInfos[RANGE_LENGTH] = length;
-        } else {
-            facesDirty = true;
-            int fromIndex = Math.min(faceRangeInfos[RANGE_INDEX], index);
-            int toIndex = Math.max(faceRangeInfos[RANGE_INDEX] + faceRangeInfos[RANGE_LENGTH], index + length);
-            faceRangeInfos[RANGE_INDEX] = fromIndex;
-            faceRangeInfos[RANGE_LENGTH] = toIndex - fromIndex;
-        }
-        setDirty(true);
-    }
-
-    /**
-     * Gets the faces, indices into the points and texCoords arrays, of this 
-     * {@code TriangleMesh}
-     *
-     * @param faces an int array that will receive the faces if it not null and 
-     * has sufficient capacity.
-     * @return an int array of faces
-     * 
-     */
-    public final int[] getFaces(int[] faces) {
-        if (this.faces == null) {
-            return null;
-        }
-
-        int faceCountInIntUnit = getFaceCount() * NUM_COMPONENTS_PER_FACE;
-        if ((faces == null) || (faceCountInIntUnit > faces.length)) {
-            faces = new int[faceCountInIntUnit];
-        }
-        System.arraycopy(this.faces, 0, faces, 0, faceCountInIntUnit);
-        return faces;
-    }
-
-    /**
-     * Gets the faces, indices into the points and texCoords arrays,
-     * associated with this {@code TriangleMesh} starting at the specified
-     * {@code index} for {@code length} number of faces.
-     * 
-     * @param index starting source faces index in this {@code TriangleMesh}
-     * @param faces destination array that will receive this {@code TriangleMesh}'s faces data
-     * @param length number of face elements to be copied
-     * @return an int array of faces
-     */
-    public final int[] getFaces(int index, int[] faces, int length) {
-        if (index < 0 || length < 0) {
-            throw new IllegalArgumentException("index and length have to be non-zero");
-        }
-
-        int lengthInIntUnit = length * NUM_COMPONENTS_PER_FACE;
-        if (lengthInIntUnit > faces.length) {
-            throw new IllegalArgumentException("length is out of range for input faces");
-        }
-        int indexOffset = index * NUM_COMPONENTS_PER_FACE;
-        int faceCountInIntUnit = getFaceCount() * NUM_COMPONENTS_PER_FACE;
-        if ((indexOffset >= faceCountInIntUnit) || 
-                ((indexOffset + lengthInIntUnit) > faceCountInIntUnit)) {
-            throw new IllegalArgumentException("index or (index + length) is out of range for this triangle mesh's faces");
-        }
-
-        if (this.faces == null) {
-            return null;
-        }
-        System.arraycopy(this.faces, indexOffset, faces, 0, lengthInIntUnit);
-        return faces;
-    }
-    
-    /**
-     * Sets the face smoothing group for each face in this {@code TriangleMesh}
+     * Gets the {@code ObservableIntegerArray} of face smoothing groups 
+     * of this {@code TriangleMesh}.
      * Smoothing affects how a mesh is rendered but it does not effect its
      * geometry. The face smoothing group value is used to control the smoothing
      * between adjacent faces.
